/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * BandUtils.cpp
 *
 *  Created on: 2011/01/14
 *      Author: HARK Development Team
 */

#include <stdexcept>
#include <BandUtils.hpp>

using namespace std;
using namespace boost;

namespace NSHarkBinaural
{

std::pair<BandUtils::BandHarmonicVectorPtr, BandUtils::BandHarmonicVectorPtr>
BandUtils::DivideBands(const BandHarmonicVector& bands, Band border)
{
    BandHarmonicVectorPtr lower(new BandHarmonicVector());
    BandHarmonicVectorPtr upper(new BandHarmonicVector());

    if (bands.size() > 0)
    {
        BandHarmonicVector::const_iterator it;

        // border以下のバンドをコピー
        for (it = bands.begin(); it != bands.end() && it->band.Index() <= border.Index(); ++it)
        {
            lower->push_back(*it);
        }

        // borderより上のバンドをコピー
        for (; it != bands.end(); ++it)
        {
            upper->push_back(*it);
        }
    }
    return pair<BandHarmonicVectorPtr, BandHarmonicVectorPtr>(lower, upper);
}

}
