/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * DirectionConverter.cpp
 *
 *  Created on: 2011/03/10
 *      Author: HARK Development Team
 */

#include <DirectionConverter.hpp>

namespace NSHarkBinaural
{

DirectionConverter::DirectionConverter(
    int increaseDegree, int beginDegree)
    : increaseDegree(increaseDegree), beginDegree(beginDegree)
{
}

size_t DirectionConverter::ToIndex(int degree) const
{
    return static_cast<size_t>((degree - this->beginDegree) / this->increaseDegree);
}

int DirectionConverter::ToDegree(size_t index) const
{
    return static_cast<int>(index) * this->increaseDegree + this->beginDegree;
}

DirectionConverter gDirConv(-5, 90);

}
